#include "GPUBucket.h"
BarinkEngine::GPU_Bucket::GPU_Bucket() {
}
BarinkEngine::GPU_Bucket::~GPU_Bucket() {

}

void BarinkEngine::GPU_Bucket::Upload(const Mesh& renderable) {

	// keep a ref to the origin in main memory 
	mesh = &renderable;

	// Upload gpu

	vertexarray.Create();
	vertexarray.Bind();

	vertexBuffer.createBuffer();
	vertexBuffer.Bind(false);
	vertexBuffer.setBufferData((void*)&renderable.vertices[0], renderable.vertices.size() * sizeof(BarinkEngine::Vertex), false);

	elementBuffer.createBuffer();
	elementBuffer.Bind(true);
	elementBuffer.setBufferData((void*)&renderable.elements[0], renderable.elements.size() * sizeof(unsigned int), true);
	
	vertexarray.AttachAttribute(0, 3, sizeof(Vertex));

	glVertexAttribPointer(1, 2, GL_FLOAT, GL_FALSE, sizeof(BarinkEngine::Vertex), (void*)0);
	glEnableVertexAttribArray(0);
	glEnableVertexAttribArray(1);

	vertexBuffer.Unbind(false);
	vertexarray.Unbind();


}
